package cn.iocoder.yudao.module.pms.service.iotsappickinglist;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotsappickinglist.vo.IotSapPickingListPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotsappickinglist.vo.IotSapPickingListSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotsappickinglist.IotSapPickingListDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotsappickinglist.IotSapPickingListMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_SAP_PICKING_LIST_NOT_EXISTS;

/**
 * PMS SAP 领料单 Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class IotSapPickingListServiceImpl implements IotSapPickingListService {

    @Resource
    private IotSapPickingListMapper iotSapPickingListMapper;

    @Override
    public Long createIotSapPickingList(IotSapPickingListSaveReqVO createReqVO) {
        // 插入
        IotSapPickingListDO iotSapPickingList = BeanUtils.toBean(createReqVO, IotSapPickingListDO.class);
        iotSapPickingListMapper.insert(iotSapPickingList);
        // 返回
        return iotSapPickingList.getId();
    }

    @Override
    public void updateIotSapPickingList(IotSapPickingListSaveReqVO updateReqVO) {
        // 校验存在
        validateIotSapPickingListExists(updateReqVO.getId());
        // 更新
        IotSapPickingListDO updateObj = BeanUtils.toBean(updateReqVO, IotSapPickingListDO.class);
        iotSapPickingListMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotSapPickingList(Long id) {
        // 校验存在
        validateIotSapPickingListExists(id);
        // 删除
        iotSapPickingListMapper.deleteById(id);
    }

    private void validateIotSapPickingListExists(Long id) {
        if (iotSapPickingListMapper.selectById(id) == null) {
            throw exception(IOT_SAP_PICKING_LIST_NOT_EXISTS);
        }
    }

    @Override
    public IotSapPickingListDO getIotSapPickingList(Long id) {
        return iotSapPickingListMapper.selectById(id);
    }

    @Override
    public PageResult<IotSapPickingListDO> getIotSapPickingListPage(IotSapPickingListPageReqVO pageReqVO) {
        return iotSapPickingListMapper.selectPage(pageReqVO);
    }

}